unit CurvesDialogUnit;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, checklst, Dialogs;

type
  TCurve=Record
    Color:Longint;
    Checked:Boolean;
    Name:Array[0..127] of char;
    Data:Pointer;
  End;
  PCurveList=^TCurveList;
  TCurveList=Array[0..0] of TCurve;
  TCurvesDialog = class(TForm)
    GroupBox1: TGroupBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    CheckListBox1: TCheckListBox;
    ColorDialog1: TColorDialog;
    Separate: TCheckBox;
    Bevel1: TBevel;
    procedure CheckListBox1DrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure FormCreate(Sender: TObject);
    procedure CheckListBox1DblClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Curves,InputCurves:PCurveList;
    CurveCount:Integer;
    Procedure ChangeCurves(aList:PCurveList;aCount:integer);
    Destructor Destroy;
  end;

implementation

{$R *.DFM}

procedure TCurvesDialog.CheckListBox1DrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
var str:PChar;
begin
  with CheckListBox1.Canvas do
  Begin
    Pen.Style:=psClear;
    Rectangle(Rect.Left,Rect.Top,Rect.Right+1,Rect.Bottom+1);
    Pen.Style:=psSolid;
    str:=@(Curves[Index].Name);
    CheckListBox1.Canvas.TextOut(Rect.Left+30,Rect.Top,StrPas(str));
    Brush.Color:=Curves[Index].Color;
    Rectangle(Rect.Left+2,Rect.Top+1,Rect.Left+28,Rect.Bottom-1);
    Brush.Color:=clWindow;
  End;
end;

procedure TCurvesDialog.FormCreate(Sender: TObject);
Begin
  CurveCount:=0;
  Curves:=nil;
End;

procedure TCurvesDialog.ChangeCurves;
Var i:integer;
begin
  //destroy old datas;
  CheckListBox1.Clear;
  if Curves<>nil then Freemem(Curves);
  //Process new curves
  CurveCount:=aCount;
  GetMem(Curves,SizeOf(TCurve)*aCount);
  for i:=0 to CurveCount-1 do
  Begin
    Curves[i].Name:=aList[i].Name;
    Curves[i].Color:=aList[i].Color;
    Curves[i].Checked:=aList[i].Checked;
    CheckListBox1.Items.Add('');
    CheckListBox1.Checked[i]:=Curves[i].Checked;
  End;

  InputCurves:=aList;
end;

procedure TCurvesDialog.CheckListBox1DblClick(Sender: TObject);
Var j:integer;
begin
  //Change color
  j:=CheckListBox1.ItemIndex;
  ColorDialog1.Color:=Curves[j].Color;
  if ColorDialog1.Execute() then
  Begin
    if (j>=0) and (j<CurveCount) then Curves[j].Color:=ColorDialog1.Color;
  End;
  CheckListBox1.Invalidate;
end;

procedure TCurvesDialog.BitBtn1Click(Sender: TObject);
Var i:integer;
begin
  for i:=0 to CurveCount-1 do
  Begin
    InputCurves[i].Color:=Curves[i].Color;
    InputCurves[i].Checked:=CheckListBox1.Checked[i];
  End;
end;

Destructor TCurvesDialog.Destroy;
Begin
  if Curves<>nil then Freemem(Curves);
  inherited;
End;

end.
