/*
  DUST: Simulator for circuits containing a SX microcontroller.
  Copyright (C) 1999 Blaise Gassend <blaise at gassend dot com> 
  and Franois-Marie Lefevere <francois-marie dot lefevere at m4x dot org>
  
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef DisassemblyListUnit
#define DisassemblyListUnit
#include <Controls.hpp>
#include <Graphics.hpp>
#include <SysUtils.hpp>
#include <Windows.hpp>
#include <Classes.hpp>
#include <Grids.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- type declarations -------------------------------------------------------
class TDisassemblyList : public Grids::TStringGrid
{
	typedef Grids::TStringGrid inherited;
public:
	Graphics::TColor clIp;
	Graphics::TColor clBreak;
	Graphics::TColor clIpPen;
	Graphics::TColor clBreakPen;
	__fastcall TDisassemblyList(Classes::TComponent* aOwner);
	virtual void __fastcall DrawCell(int ACol, int ARow, const Windows::TRect &ARect, Grids::TGridDrawState
		AState);
	__fastcall virtual ~TDisassemblyList(void) { }
	__fastcall TDisassemblyList(HWND ParentWindow) : Grids::TStringGrid(ParentWindow) { }

};

#endif	// DisassemblyListUnit
