unit OscilloUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompFormUnit, StdCtrls, ExtCtrls, Menus, CurvesDialogUnit;

type
  PDoubleArray=^TDoubleArray;
  TDoubleArray=Array[0..0] of Double;
  PDouble=^Double;
  TOnGetPoints=function (i:integer;Var P:PChar):PDouble of object;
  TIntFunct=function :integer of object;
  TOscilloControls = class (TCompInfo)
    //TEMPORAIRE
    n:longint;

    SinglePlot : Boolean;
    PaintBox1: TPaintBox;
    GroupBox1: TGroupBox;
    ScrollBox1: TScrollBox;
    Panel1: TPanel;
    NbPoints:Longint;
    //
    Curves:PCurveList;
    CurveCount:Longint;
    //
    GetCurveCount:TIntFunct;
    GetCurvePos:TIntFunct;
    GetPoints:TOnGetPoints;
    //
    Procedure SetName(s:PChar);
    procedure ProcessCurves;
    procedure SpreadDragDrop;override;
  End;
  TOscilloW = class(TCompForm)
    PopupMenu1: TPopupMenu;
    GroupBox1: TGroupBox;
    Displaypreferences1: TMenuItem;
    Panel1: TPanel;
    ScrollBox1: TScrollBox;
    PaintBox1: TPaintBox;
    procedure FormCreate(Sender: TObject);
    procedure ControlResize(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure Displaypreferences1Click(Sender: TObject);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  OscilloW: TOscilloW;

implementation

{$R *.DFM}

procedure TOscilloControls.ProcessCurves;
Var Count,t,i:Longint;
    NewCurves:PCurveList;
    str:PChar;
Begin
  if (Assigned(GetCurveCount)) and (Assigned(GetPoints)) then
  Begin
    Count:=GetCurveCount;
    GetMem(NewCurves,SizeOf(TCurve)*Count);
    For t:=0 to Count-1 do
    Begin
      NewCurves[t].Data:=GetPoints(t,str);
      StrPCopy(@NewCurves[t].Name,str);
      //Default values
      NewCurves[t].Checked:=true;
      NewCurves[t].Color:=clRed;
      //Read the old list to see if these values are already defined
      For i:=0 to CurveCount-1 do
        if NewCurves[t].Data=Curves[i].Data then
        Begin
          NewCurves[t].Checked:=Curves[i].Checked;
          NewCurves[t].Color:=Curves[i].Color;
        End;
    End;
    if Curves<>nil then FreeMem(Curves);
    Curves:=NewCurves;
    CurveCount:=Count;
    PaintBox1.Width:=NbPoints;
    if NbPoints>PaintBox1.Width then
      PaintBox1.Height:=ScrollBox1.Height-17
    else
      PaintBox1.Height:=ScrollBox1.Height;
  End;
End;

procedure TOscilloControls.SpreadDragDrop;
Begin
  GroupBox1.OnStartDrag:=Control.OnStartDrag;
  GroupBox1.OnDragDrop:=Control.OnDragDrop;
  GroupBox1.OnEndDrag:=Control.OnEndDrag;
  GroupBox1.OnDragOver:=Control.OnDragOver;

  PaintBox1.OnStartDrag:=Control.OnStartDrag;
  PaintBox1.OnDragDrop:=Control.OnDragDrop;
  PaintBox1.OnEndDrag:=Control.OnEndDrag;
  PaintBox1.OnDragOver:=Control.OnDragOver;

  ScrollBox1.OnDragDrop:=Control.OnDragDrop;
  ScrollBox1.OnEndDrag:=Control.OnEndDrag;
  ScrollBox1.OnDragOver:=Control.OnDragOver;

  Panel1.OnStartDrag:=Control.OnStartDrag;
  Panel1.OnDragDrop:=Control.OnDragDrop;
  Panel1.OnEndDrag:=Control.OnEndDrag;
  Panel1.OnDragOver:=Control.OnDragOver;
End;

Procedure TOscilloControls.SetName;
Begin
  GroupBox1.Caption:=s;
End;
//******************************************************************************

procedure TOscilloW.FormCreate(Sender: TObject);
Var P:TOscilloControls;
    t:integer;
begin
  P:=TOscilloControls.Create();
  Control.Tag:=integer(P);
  P.PaintBox1:=PaintBox1;
  P.GroupBox1:=GroupBox1;
  P.ScrollBox1:=ScrollBox1;
  P.Panel1:=Panel1;
  P.SinglePlot:=False;

  P.Curves:=nil;
  P.Curvecount:=0;
  //TEMPORAIRE
  P.n:=0;
  
  for t:=0 to Componentcount-1 do
      Components[t].Tag:=longint(P);
end;

procedure TOscilloW.ControlResize(Sender: TObject);
begin
  inherited;
  With TOscilloControls(TControl(Sender).Tag) do
  Begin
    PaintBox1.Height:=ScrollBox1.ClientHeight;
  End;
end;

procedure TOscilloW.PaintBox1Paint(Sender: TObject);
Type PPointArray=^TPointArray;
     TPointArray=Array[0..0] of TPoint;
Var VisibleCount,t,i:Longint;

  Procedure DrawCurve(Data:PDoubleArray;y1,y2:Integer;v1,v2:double;color:Longint);
  Var t,lasty:integer;
      j,j2:integer;
  Begin
    With TOscilloControls(TControl(Sender).Tag) do
    Begin
      PaintBox1.Canvas.Pen.Color:=color;
      j:=ScrollBox1.HorzScrollBar.Position;
      j2:=NbPoints;
      if j2>j+ScrollBox1.Width then j2:=j+ScrollBox1.Width;
      if (j>=0) and (j2<NbPoints) and (j<NbPoints) then
      Begin
        lasty:=Round(y1+(Data[j]-v1)*(y2-y1)/(v2-v1));
        PaintBox1.Canvas.MoveTo(j,lasty);
        for t:=j+1 to j2-1 do
        Begin
          PaintBox1.Canvas.LineTo(t,lasty);
          lasty:=Round(y1+(Data[t]-v1)*(y2-y1)/(v2-v1));
          PaintBox1.Canvas.LineTo(t,lasty);
        End;
        PaintBox1.Canvas.LineTo(j2,lasty);
      End;
    End;
  End;

var w:word;
begin
  asm
    finit
  end;
  //Draw Curves.
  With TOscilloControls(TControl(Sender).Tag) do
  Begin
    if (Curves<>nil) then
    Begin
      //inc(n);//TEMPORAIRE
      //Panel1.Caption:=Format('%d',[n]);
      VisibleCount:=0;
      for t:=0 to CurveCount-1 do
        if Curves[t].Checked then VisibleCount:=VisibleCount+1;
      i:=0;
      for t:=0 to CurveCount-1 do
      Begin
        if Curves[t].Checked then
        Begin
          //Display curve
          if SinglePlot then
            DrawCurve(PDoubleArray(Curves[t].Data),PaintBox1.Height-1,0,-0.3,5.3,Curves[t].Color)
          else Begin
            DrawCurve(PDoubleArray(Curves[t].Data),
              Round((i+1)*PaintBox1.Height/VisibleCount),
              Round(i*PaintBox1.Height/VisibleCount),
              -0.3,5.3,Curves[t].Color);
            i:=i+1;
          End;
        End;
      End;
      if Assigned(GetCurvePos) then
      Begin
        //Draw a vertical bar to show the progression of datas
        w:=GetCurvePos;
        PaintBox1.Canvas.Pen.Color:=clBlack;
        PaintBox1.Canvas.MoveTo(w,0);
        PaintBox1.Canvas.LineTo(w,PaintBox1.Height);
      End;
    End;
  End;
end;

procedure TOscilloW.Displaypreferences1Click(Sender: TObject);
Var CurvesDialog:TCurvesDialog;
begin
  inherited;
  With TOscilloControls(TControl(Sender).Tag) do
  Begin
    CurvesDialog:=TCurvesDialog.Create(Application);
    CurvesDialog.ChangeCurves(Curves,CurveCount);
    CurvesDialog.Separate.Checked:=not SinglePlot;
    if CurvesDialog.ShowModal=mrOK then
    Begin
      SinglePlot:=not CurvesDialog.Separate.Checked;
    End;
    PaintBox1.Invalidate();
    CurvesDialog.Destroy;
  End;
end;

procedure TOscilloW.PaintBox1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  inherited;
  With TOscilloControls(TComponent(Sender).Tag) do
  Begin
    if Assigned(Control.OnMouseDown) then
      Control.OnMouseDown(Sender,Button,Shift,X,Y);
  End;
end;

end.
