unit PinViewer;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompFormUnit, ExtCtrls, StdCtrls, Menus;

type
  TPinInfo= class (TCompInfo)
    PopupMenu1: TPopupMenu;
    Name1: TMenuItem;
    Label2: TLabel;
    Panel1: TPanel;
    VIN: TLabel;
    VOUT: TLabel;
    Z: TLabel;
    LabelIn: TLabel;
    LabelOut :TLabel;
    LabelZ : TLabel;
    NameLength:Integer;
    Constructor Create;
    Procedure SpreadDragDrop;override;
  End;
  TPinBox = class(TCompForm)
    PopupMenu1: TPopupMenu;
    LongName: TMenuItem;
    ShortName: TMenuItem;
    NoneName: TMenuItem;
    Label2: TLabel;
    Panel1: TPanel;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    LabelIn: TLabel;
    LabelOut :TLabel;
    LabelZ : TLabel;
    VIN: TLabel;
    VOUT: TLabel;
    Z: TLabel;
    procedure ControlResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Label2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure LongNameClick(Sender: TObject);
    procedure ShortNameClick(Sender: TObject);
    procedure NoneNameClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

implementation

{$R *.DFM}

Constructor TPinInfo.Create;
Begin
  inherited;
  NameLength:=1;
End;

Procedure TPinInfo.SpreadDragDrop;
Begin
  Panel1.OnDragDrop:=Control.OnDragDrop;
  Panel1.OnDragOver:=Control.OnDragOver;
  Label2.OnDragDrop:=Control.OnDragDrop;
  Label2.OnDragOver:=Control.OnDragOver;
  LabelIn.OnDragDrop:=Control.OnDragDrop;
  LabelIn.OnDragOver:=Control.OnDragOver;
  LabelOut.OnDragDrop:=Control.OnDragDrop;
  LabelOut.OnDragOver:=Control.OnDragOver;
  LabelZ.OnDragDrop:=Control.OnDragDrop;
  LabelZ.OnDragOver:=Control.OnDragOver;
  VIN.OnDragDrop:=Control.OnDragDrop;
  VIN.OnDragOver:=Control.OnDragOver;
  VOUT.OnDragDrop:=Control.OnDragDrop;
  VOUT.OnDragOver:=Control.OnDragOver;
  Z.OnDragDrop:=Control.OnDragDrop;
  Z.OnDragOver:=Control.OnDragOver;

End;

//******************************************************************************

procedure TPinBox.ControlResize(Sender: TObject);
begin
  inherited;
  With TPinInfo(TComponent(Sender).Tag) do
  Begin
    Panel1.Left:=Control.Width-Panel1.Width;
  End;
end;

procedure TPinBox.FormCreate(Sender: TObject);
Var P:TPinInfo;
    t:integer;
begin
  inherited;
  P:=TPinInfo.Create();
  Control.Tag:=Longint(P);
  P.LongName:= LongName;
  P.ShortName:= ShortName;
  P.NoneName:= NoneName;
  P.Label2:= Label2;
  P.Panel1:= Panel1;
  P.VIN:= VIN;
  P.VOUT:=VOUT;
  P.Z:=Z;
  P.LabelIn:=LabelIn;
  P.LabelOut:=LabelOut;
  P.LabelZ:=LabelZ;
  for t:=0 to Componentcount-1 do
      Components[t].Tag:=longint(P);
end;

procedure TPinBox.Label2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  inherited;
  With TPinInfo(TComponent(Sender).Tag) do
  Begin
    if Assigned(Control.OnMouseDown) then
      Control.OnMouseDown(Sender,Button,Shift,X,Y);
  End;
end;

procedure TPinBox.NoneNameClick(Sender: TObject);
begin
  inherited;
  With TPinInfo(TComponent(Sender).Tag) do
  Begin
    NameLength:=0;
    NoneName.Checked:=True;
    If Assigned(OnUpdate) then OnUpdate;
  End;
end;

procedure TPinBox.ShortNameClick(Sender: TObject);
begin
  inherited;
  With TPinInfo(TComponent(Sender).Tag) do
  Begin
    NameLength:=1;
    ShortName.Checked:=True;
    If Assigned(OnUpdate) then OnUpdate;
  End;
end;

procedure TPinBox.LongNameClick(Sender: TObject);
begin
  inherited;
  With TPinInfo(TComponent(Sender).Tag) do
  Begin
    NameLength:=2;
    LongName.Checked:=True;
    If Assigned(OnUpdate) then OnUpdate;
  End;
end;
end.
