unit ProjectViewerUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompFormUnit, ExtCtrls, ComCtrls, StdCtrls;

type
  TTreeNodeProc = procedure (Node : TTreeNode) of object;
  TProjectInfo=class (TCompInfo)
    TreeView1: TTreeView;
    GroupBox1: TGroupBox;
    OnTreeExpand : TTreeNodeProc;
    Procedure SpreadDragDrop;override;
  End;
  TProjectViewer = class(TCompForm)
    GroupBox1: TGroupBox;
    TreeView1: TTreeView;
    procedure FormCreate(Sender: TObject);
    procedure TreeView1Expanded(Sender: TObject; Node: TTreeNode);
    procedure TreeView1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TreeView1Compare(Sender: TObject; Node1, Node2: TTreeNode;
      Data: Integer; var Compare: Integer);
    procedure GroupBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TreeView1Expanding(Sender: TObject; Node: TTreeNode;
      var AllowExpansion: Boolean);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

implementation

{$R *.DFM}

procedure TProjectInfo.SpreadDragDrop;
Begin
  GroupBox1.OnStartDrag:=Control.OnStartDrag;
  GroupBox1.OnDragDrop:=Control.OnDragDrop;
  GroupBox1.OnEndDrag:=Control.OnEndDrag;
  GroupBox1.OnDragOver:=Control.OnDragOver;

  TreeView1.OnDragDrop:=Control.OnDragDrop;
  TreeView1.OnDragOver:=Control.OnDragOver;
End;

//******************************************************************************

procedure TProjectViewer.FormCreate(Sender: TObject);
Var P:TProjectInfo;
    t:integer;
begin
  inherited;
  P:=TProjectInfo.Create;
  Control.Tag:=longint(P);
  P.TreeView1:=TreeView1;
  P.GroupBox1:=GroupBox1;
  for t:=0 to Componentcount-1 do
      Components[t].Tag:=longint(P);
end;

procedure TProjectViewer.TreeView1Expanded(Sender: TObject;
  Node: TTreeNode);
begin
  inherited;
  //
end;

procedure TProjectViewer.TreeView1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  inherited;
  //
end;

procedure TProjectViewer.TreeView1Compare(Sender: TObject; Node1,
  Node2: TTreeNode; Data: Integer; var Compare: Integer);
begin
  inherited;
  if Node2.Text>Node1.Text then Compare:=-1 else
    if Node2.Text=Node1.Text then Compare:=0 else Compare:=1;
end;

procedure TProjectViewer.GroupBox1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  inherited;
  With TProjectInfo(TComponent(Sender).Tag) do
  Begin
    if Assigned(Control.OnMouseDown) then
      Control.OnMouseDown(Sender,Button,Shift,X,Y);
  End;    
end;

procedure TProjectViewer.TreeView1Expanding(Sender: TObject;
  Node: TTreeNode; var AllowExpansion: Boolean);
begin
  inherited;
  With TProjectInfo(TComponent(Sender).Tag) do
  Begin
    If Assigned(OnTreeExpand) then OnTreeExpand(Node);
  End;
end;

end.
