/*
  DUST: Simulator for circuits containing a SX microcontroller.
  Copyright (C) 1999 Blaise Gassend <blaise at gassend dot com> 
  and Franois-Marie Lefevere <francois-marie dot lefevere at m4x dot org>
  
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

//---------------------------------------------------------------------------
#ifndef TestUnitH
#define TestUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Dialogs.hpp>
#include <Menus.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Buttons.hpp>
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// Composants grs par l'EDI
    TMainMenu *MainMenu1;
    TMenuItem *Fichiers1;
    TOpenDialog *OpenDialog;
    TMemo *Memo1;
    TStatusBar *StatusBar1;
    TTimer *Timer1;
    TMenuItem *Quit1;
    TBevel *Bevel1;
    TPanel *Panel1;
    TEdit *NameEdit;
    TTimer *Timer2;
    TMenuItem *Windows1;
    TMenuItem *Newwindow1;
    TMenuItem *Open1;
    TMenuItem *About1;
    void __fastcall Run1Click(TObject *Sender);
    void __fastcall Break1Click(TObject *Sender);
    void __fastcall Timer1Timer(TObject *Sender);
    void __fastcall Quit1Click(TObject *Sender);
    void __fastcall FormResize(TObject *Sender);
    void __fastcall NameEditMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall NameEditStartDrag(TObject *Sender,
          TDragObject *&DragObject);
    void __fastcall Timer2Timer(TObject *Sender);
    void __fastcall Newwindow1Click(TObject *Sender);
    void __fastcall Open1Click(TObject *Sender);
    
    void __fastcall About1Click(TObject *Sender);
    
    void __fastcall FormDestroy(TObject *Sender);
private:	// Dclarations de l'utilisateur
public:		// Dclarations de l'utilisateur
    int active;
    __fastcall TForm1(TComponent* Owner);
    void __fastcall OpenFile(char *name);
};

int Simulate(int usermsg);
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
extern int Refreshspeed;
//---------------------------------------------------------------------------
#endif
