unit VariableUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompFormUnit, StdCtrls, Buttons, ExtCtrls, Menus, StringEditUnit;

type

  TVariableInfo=class (TCompInfo)
    value,lastvalue,color:String;
    SymbolWidth:Integer;
    Sign:Boolean;
    Label2: TLabel;
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    ValueBox: TPaintBox;
    Base:Integer;
    NameLength:Integer;
    //
    Binary: TMenuItem;
    Octal: TMenuItem;
    Decimal: TMenuItem;
    Hexadecimal: TMenuItem;
    //
    Unsigned: TMenuItem;
    Signed: TMenuItem;
    //
    ModifDialog : TForm;
    //
    OnChange: TStringProc;
    OnClear : TSimpleProc;
    OnRandom: TSimpleProc;
    OnIncrement:TIntProc;
    Procedure SetName(s:PChar);
    Procedure SetValue(s:PChar);
    Procedure SetSign(b:Boolean);
    Procedure SpreadDragDrop;override;
  End;
  TVariableViewer = class(TCompForm)
    Label2: TLabel;
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    PopupMenu1: TPopupMenu;
    Base1: TMenuItem;
    Binary: TMenuItem;
    Octal: TMenuItem;
    Decimal: TMenuItem;
    Hexadecimal: TMenuItem;
    N1: TMenuItem;
    ValueBox: TPaintBox;
    Sign1: TMenuItem;
    Unsigned: TMenuItem;
    Signed: TMenuItem;
    Data1: TMenuItem;
    Clear: TMenuItem;
    ShortName: TMenuItem;
    LongName: TMenuItem;
    NoneName: TMenuItem;
    Randomize1: TMenuItem;
    Increment1: TMenuItem;
    Decrement1: TMenuItem;
    procedure ControlResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BinaryClick(Sender: TObject);
    procedure OctalClick(Sender: TObject);
    procedure DecimalClick(Sender: TObject);
    procedure HexadecimalClick(Sender: TObject);
    procedure NoneNameClick(Sender: TObject);
    procedure ShortNameClick(Sender: TObject);
    procedure LongNameClick(Sender: TObject);
    procedure ValueBoxPaint(Sender: TObject);
    procedure Label2Click(Sender: TObject);
    procedure UnsignedClick(Sender: TObject);
    procedure SignedClick(Sender: TObject);
    procedure BitBtn1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Label2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BitBtn1Click(Sender: TObject);
    procedure ClearClick(Sender: TObject);
    procedure Randomize1Click(Sender: TObject);
    procedure Increment1Click(Sender: TObject);
    procedure Decrement1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

implementation

{$R *.DFM}

procedure TVariableInfo.SetName;
Begin
  Label2.Caption:=StrPas(s);
  Control.Invalidate;
End;

procedure TVariableInfo.SetValue;
Begin
  value:=StrPas(s);
  color:=lastvalue;
  lastvalue:=value;
  Control.Invalidate;
End;

Procedure TVariableInfo.SetSign(b:boolean);
Begin
  Sign:=b;
  if Sign then Signed.Checked:=true else Unsigned.Checked:=true;
  Control.Invalidate;
End;

Procedure TVariableInfo.SpreadDragDrop;
Begin
  ValueBox.OnStartDrag:=Control.OnStartDrag;
  ValueBox.OnDragDrop:=Control.OnDragDrop;
  ValueBox.OnEndDrag:=Control.OnEndDrag;
  ValueBox.OnDragOver:=Control.OnDragOver;

  Label2.OnStartDrag:=Control.OnStartDrag;
  Label2.OnDragDrop:=Control.OnDragDrop;
  Label2.OnEndDrag:=Control.OnEndDrag;
  Label2.OnDragOver:=Control.OnDragOver;
End;

//******************************************************************************
procedure TVariableViewer.ControlResize(Sender: TObject);
begin
  inherited;
  With TVariableInfo(TComponent(Sender).Tag) do
  Begin
  End;
end;

procedure TVariableViewer.FormCreate(Sender: TObject);
Var P:TVariableInfo;
    t:integer;
begin
  inherited;
  P:=TVariableInfo.Create;
  Control.Tag:=longint(P);
  P.SymbolWidth:=80;
  P.lastvalue:='';
  P.color:='0';
  P.value:='0';
  P.Label2:=Label2;
  P.Panel1:=Panel1;
  P.BitBtn1:=BitBtn1;
  P.ValueBox:=ValueBox;
  P.Base:=10;
  P.NameLength:=1;
  P.Binary:=Binary;
  P.Octal:=Octal;
  P.Decimal:=Decimal;
  P.Hexadecimal:=Hexadecimal;
  P.ShortName:=ShortName;
  P.LongName:=LongName;
  P.NoneName:=NoneName;
  P.Signed:=Signed;
  P.UnSigned:=UnSigned;
  P.ModifDialog:=nil;
  for t:=0 to Componentcount-1 do
      Components[t].Tag:=longint(P);
end;

procedure TVariableViewer.BinaryClick(Sender: TObject);
begin
  inherited;
  With TVariableInfo(TComponent(Sender).Tag) do
  Begin
    Base:=2;
    Binary.Checked:=True;
    If Assigned(OnUpdate) then OnUpdate;
  End;
end;

procedure TVariableViewer.OctalClick(Sender: TObject);
begin
  inherited;
  With TVariableInfo(TComponent(Sender).Tag) do
  Begin
    Base:=8;
    Octal.Checked:=True;
    If Assigned(OnUpdate) then OnUpdate;
  End;
end;

procedure TVariableViewer.DecimalClick(Sender: TObject);
begin
  inherited;
  With TVariableInfo(TComponent(Sender).Tag) do
  Begin
    Base:=10;
    Decimal.Checked:=True;
    If Assigned(OnUpdate) then OnUpdate;
  End;
end;

procedure TVariableViewer.HexadecimalClick(Sender: TObject);
begin
  inherited;
  With TVariableInfo(TComponent(Sender).Tag) do
  Begin
    Base:=16;
    Hexadecimal.Checked:=True;
    If Assigned(OnUpdate) then OnUpdate;
  End;
end;

procedure TVariableViewer.NoneNameClick(Sender: TObject);
begin
  inherited;
  With TVariableInfo(TComponent(Sender).Tag) do
  Begin
    NameLength:=0;
    NoneName.Checked:=True;
    If Assigned(OnUpdate) then OnUpdate;
  End;
end;

procedure TVariableViewer.ShortNameClick(Sender: TObject);
begin
  inherited;
  With TVariableInfo(TComponent(Sender).Tag) do
  Begin
    NameLength:=1;
    ShortName.Checked:=True;
    If Assigned(OnUpdate) then OnUpdate;
  End;
end;

procedure TVariableViewer.LongNameClick(Sender: TObject);
begin
  inherited;
  With TVariableInfo(TComponent(Sender).Tag) do
  Begin
    NameLength:=2;
    LongName.Checked:=True;
    If Assigned(OnUpdate) then OnUpdate;
  End;
end;

procedure TVariableViewer.ValueBoxPaint(Sender: TObject);
Var x,t,t1:longint;
    CarWidth:Longint;
begin
  inherited;
  With TVariableInfo(TComponent(Sender).Tag) do
  Begin
    With ValueBox.Canvas do
    Begin
      CarWidth:=TextWidth('A');
      x:=ValueBox.Width;
      t1:=length(color);
      for t:=length(value) downto 1 do
      Begin
        x:=x-CarWidth;
        if t1>0 then
          if color[t1]=value[t] then Font.Color:=clBlack else Font.Color:=clRed
        else Font.Color:=clRed;
        if t=length(value) then Font.Color:=clBlue;
        t1:=t1-1;
        TextOut(x,0,value[t]);
      End;
      SymbolWidth:=length(value)*CarWidth;
    End;
  End;
end;

procedure TVariableViewer.Label2Click(Sender: TObject);
begin
  inherited;
  With TVariableInfo(TComponent(Sender).Tag) do
  Begin
    BitBtn1.SetFocus;
  End;
end;

procedure TVariableViewer.UnsignedClick(Sender: TObject);
begin
  inherited;
  With TVariableInfo(TComponent(Sender).Tag) do
  Begin
    Sign:=false;
    Unsigned.Checked:=True;
    If Assigned(OnUpdate) then OnUpdate;
  End;
end;

procedure TVariableViewer.SignedClick(Sender: TObject);
begin
  inherited;
  With TVariableInfo(TComponent(Sender).Tag) do
  Begin
    Sign:=true;
    Signed.Checked:=True;
    If Assigned(OnUpdate) then OnUpdate;
  End;
end;

procedure TVariableViewer.BitBtn1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  inherited;
  With TVariableInfo(TComponent(Sender).Tag) do
  Begin
    case Key of
      vk_ADD:begin
        if Assigned(OnClear) then OnIncrement(1);
      end;
      vk_SUBTRACT:begin
        if Assigned(OnClear) then OnIncrement(-1);
      end;
    end;
  end;
end;

procedure TVariableViewer.Label2MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  inherited;
  With TVariableInfo(TComponent(Sender).Tag) do
  Begin
    BitBtn1.SetFocus;
    if Assigned(Control.OnMouseDown) then
      Control.OnMouseDown(Sender,Button,Shift,X,Y);
  End;
end;

procedure TVariableViewer.BitBtn1Click(Sender: TObject);
begin
  inherited;
  With TVariableInfo(TComponent(Sender).Tag) do
  Begin
    if ModifDialog=nil then
    Begin
      ModifDialog:=TStringEdit.Create(nil);
      TStringEdit(ModifDialog).OnValidate:=OnChange;
    End;
    TStringEdit(ModifDialog).Caption:='Modify '+Label2.Caption;
    TStringEdit(ModifDialog).VarEdit.Text:=Value;
    ModifDialog.Show;
    ModifDialog.SetFocus;
  End;
end;

procedure TVariableViewer.ClearClick(Sender: TObject);
begin
  inherited;
  With TVariableInfo(TComponent(Sender).Tag) do
  Begin
    if Assigned(OnClear) then OnClear;
  End;
end;

procedure TVariableViewer.Randomize1Click(Sender: TObject);
begin
  inherited;
  With TVariableInfo(TComponent(Sender).Tag) do
  Begin
    if Assigned(OnRandom) then OnRandom;
  End;
end;

procedure TVariableViewer.Increment1Click(Sender: TObject);
begin
  inherited;
  With TVariableInfo(TComponent(Sender).Tag) do
  Begin
    if Assigned(OnClear) then OnIncrement(1);
  End;
end;

procedure TVariableViewer.Decrement1Click(Sender: TObject);
begin
  inherited;
  With TVariableInfo(TComponent(Sender).Tag) do
  Begin
    if Assigned(OnClear) then OnIncrement(-1);
  End;
end;


end.
