/*
  DUST: Simulator for circuits containing a SX microcontroller.
  Copyright (C) 1999 Blaise Gassend <blaise at gassend dot com> 
  and Franois-Marie Lefevere <francois-marie dot lefevere at m4x dot org>
  
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

//---------------------------------------------------------------------------
#ifndef WindowFormUnitH
#define WindowFormUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include <Buttons.hpp>
//---------------------------------------------------------------------------
class TWindowForm : public TForm
{
__published:	// Composants grs par l'EDI
    TScrollBox *Container;
    TBevel *Bevel1;
    TMainMenu *MainMenu1;
    TMenuItem *Options1;
    TMenuItem *Autosize;
    TMenuItem *Alwaysontop;
    TMenuItem *N1;
    TMenuItem *Copytexttoclipboard1;
    TMenuItem *Newwindow1;
    TPanel *Panel1;
    TSpeedButton *SpeedButton1;
    TSpeedButton *SpeedButton2;
    TSpeedButton *SpeedButton3;
    TSpeedButton *SpeedButton4;
    TEdit *NameEdit;
    TBevel *Bevel2;
    TPanel *Panel2;
    TImage *Vbox;
    TPanel *Panel3;
    TImage *Hbox;
    TPanel *TrashP;
    TImage *Trash;
    TMenuItem *HideToolbar1;
    TMenuItem *Simulation1;
    TMenuItem *Run1;
    TMenuItem *Step1;
    TMenuItem *Trace1;
    TMenuItem *Ticks1;
    TMenuItem *N2;
    TMenuItem *Reset1;
    TMenuItem *Break1;
    TMenuItem *Animatemodes1;
    TMenuItem *Normal;
    TMenuItem *Fast;
    TMenuItem *Norefresh;
    TMenuItem *Animate1;
    TMenuItem *Setfastanimationspeed1;
    TMenuItem *Byticks1;
    TMenuItem *Bystep1;
    TMenuItem *Bytrace1;
    TSpeedButton *SpeedButton5;
    void __fastcall OrganizeAutoClick(TObject *Sender);


    void __fastcall AutosizeClick(TObject *Sender);
    void __fastcall AlwaysontopClick(TObject *Sender);
    void __fastcall Newwindow1Click(TObject *Sender);

    void __fastcall Copytexttoclipboard1Click(TObject *Sender);


    void __fastcall NameEditMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall NameEditStartDrag(TObject *Sender,
          TDragObject *&DragObject);
    void __fastcall Panel1Resize(TObject *Sender);
    void __fastcall TrashDragDrop(TObject *Sender, TObject *Source, int X,
          int Y);
    void __fastcall HboxStartDrag(TObject *Sender,
          TDragObject *&DragObject);
    void __fastcall VboxStartDrag(TObject *Sender,
          TDragObject *&DragObject);
    void __fastcall TrashDragOver(TObject *Sender, TObject *Source, int X,
          int Y, TDragState State, bool &Accept);
    void __fastcall NameEditDragOver(TObject *Sender, TObject *Source,
          int X, int Y, TDragState State, bool &Accept);
    void __fastcall NameEditDragDrop(TObject *Sender, TObject *Source,
          int X, int Y);
    void __fastcall GETMINMAXINFO(TMessage &Message);
    void __fastcall HideToolbar1Click(TObject *Sender);
    void __fastcall NormalClick(TObject *Sender);
    void __fastcall FastClick(TObject *Sender);
    void __fastcall NorefreshClick(TObject *Sender);
    void __fastcall Step1Click(TObject *Sender);
    void __fastcall Trace1Click(TObject *Sender);
    void __fastcall Reset1Click(TObject *Sender);
    void __fastcall Break1Click(TObject *Sender);
    void __fastcall Run1Click(TObject *Sender);
    void __fastcall Ticks1Click(TObject *Sender);
    void __fastcall Bytrace1Click(TObject *Sender);
    void __fastcall Bystep1Click(TObject *Sender);
    void __fastcall Byticks1Click(TObject *Sender);
    void __fastcall Animatemodes1Click(TObject *Sender);
    void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
    void __fastcall Setfastanimationspeed1Click(TObject *Sender);
    void __fastcall FormDestroy(TObject *Sender);
private:	// Dclarations de l'utilisateur
public:		// Dclarations de l'utilisateur
    int closing;
    __fastcall TWindowForm(TComponent* Owner);
    void __fastcall UpdateSpeed();
    window *win;
BEGIN_MESSAGE_MAP
  MESSAGE_HANDLER(WM_GETMINMAXINFO, TMessage, GETMINMAXINFO)
END_MESSAGE_MAP(TForm)
};
//---------------------------------------------------------------------------
extern PACKAGE TWindowForm *WindowForm;
//---------------------------------------------------------------------------
#endif
