/*
  DUST: Simulator for circuits containing a SX microcontroller.
  Copyright (C) 1999 Blaise Gassend <blaise at gassend dot com> 
  and Franois-Marie Lefevere <francois-marie dot lefevere at m4x dot org>
  
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
USEFORM("TestUnit.cpp", Form1);
USEFORM("WindowFormUnit.cpp", WindowForm);
USEFORMNS("CompFormUnit.pas", Compformunit, CompForm);
USEFORMNS("OscilloUnit.pas", Oscillounit, OscilloW);
USEUNIT("all.cpp");
USEUNIT("DisassemblyListUnit.pas");
USEFORMNS("VariableUnit.pas", Variableunit, VariableViewer);
USEFORMNS("StringEditUnit.pas", Stringeditunit, StringEdit);
USEFORMNS("Arrayunit.pas", Arrayunit, ArrayViewer);
USEFORMNS("RealUnit.pas", Realunit, RealViewer);
USEFORMNS("BoxUnit.pas", Boxunit, Box);
USEFORMNS("CurvesDialogUnit.pas", Curvesdialogunit, CurvesDialog);
USEFORMNS("ProjectViewerUnit.pas", Projectviewerunit, ProjectViewer);
USEFORMNS("PinViewer.pas", Pinviewer, PinBox);
USERES("Windust.res");
USEFORM("about.cpp", AboutBox);
USEFORM("AnimSpeedUnit.cpp", AnimSpeedDialog);
//---------------------------------------------------------------------------
WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
    try
    {
        Application->Initialize();
        Application->Title = "WIN DUST";
        Application->CreateForm(__classid(TForm1), &Form1);
        Application->CreateForm(__classid(TAboutBox), &AboutBox);
        Application->CreateForm(__classid(TAnimSpeedDialog), &AnimSpeedDialog);
        Application->Run();
    }
    catch (Exception &exception)
    {
        Application->ShowException(&exception);
    }
    return 0;
}
//---------------------------------------------------------------------------
