%{

macrocomponenttype *CurComponentType = new macrocomponenttype;

struct constructorname
{
  int name;
  attribute *attribs;
};

struct range
{
  int i1, i2;
};

int ParsingPlug = 0;

%}
 
%union 
{
  char *str;
  int i;
  real r;
  symbolname *symb;
  list<symbolname> *symblist;
  attribute *attrib;
  _attribute *_attrib;
  displayboxconstructor *box;
  constructorname sname;
  list<componentconstructor> *lcc;
  componentconstructor *cc;
  symbolconstructor *sc;
  symbolcopyconstructor *scsc;
  range rg;
  plugconstructor *plug;
  netconstructor *net;
  busconstructor *bus;
  variableconstructor *var;
}

%type 	<sname> 	symbolname
%type	<attrib>	attributes
%type 	<_attrib> 	attribute
%type 	<i> 		extendedname
%type 	<symb> 		composedname composednametail
%type 	<symblist> 	pinlist namelist namelistdef namelistsymbolname
%type	<symblist>	namelistsymbolnametail pluglist
%type 	<box>		boxdefs boxsymbol
%type	<lcc>		componentconstructorlist
%type 	<cc>		componentconstructor
%type	<sc>		boxdef
%type   <scsc>		symbolcopysymbol
%type	<plug>		plugsymbol
%type	<rg>		range
%type	<net>		netsymbol
%type	<bus>		bussymbol
%type	<var>		varsymbol 
%token  LEFT_CURLY RIGHT_CURLY LEFT_PAREN RIGHT_PAREN 
%token	LEFT_POINTY RIGHT_POINTY
%token  SEMICOLON COMMA SLASH COLON MINUS EQUAL PERCENT TILDA
%token  COMPONENT NET HBOX VBOX SYMBOL PLUG PLUGTYPE VAR
%token  <i> NAME INTEGER BUS
%token	<r> REAL UNIT
%token  <str> STRING

%%

circuit
  :globaldefs

/*****************************************
		  GLOBAL
******************************************/

globaldefs 
  :
  |globaldef SEMICOLON globaldefs
  |SEMICOLON globaldefs
//  |error SEMICOLON globaldefs { yyerror("Syntax error."); yyerrok; }

globaldef
  :componenttype
  |boxdef { $1->addattribstoend(Project.getattributes()); Project.windowrootconstructors = new list<symbolconstructor>($1, Project.windowrootconstructors); }
  |plugtype 
  |attributes { Project.attributes = $1->addattribstoend(Project.getattributes()); }

/*****************************************
	  COMPONENTTYPE (oly in global)
******************************************/

componenttype
:COMPONENT { CurComponentType = new macrocomponenttype; CurComponentType->AddAttributes(Project.getattributes()); } NAME LEFT_CURLY componentdefs RIGHT_CURLY 
       { 
         CurComponentType->name = $3; 
	 revlist(CurComponentType->symbolconstructors);
         Project.componenttypes = new list<componenttype>(CurComponentType, Project.componenttypes);  
       }

componentdefs
  :
  |componentdef SEMICOLON componentdefs
  |SEMICOLON componentdefs
//  |error SEMICOLON componentdefs { yyerror("Syntax error in component type definition."); yyerrok; }

componentdef
  :netsymbol { CurComponentType->AddSymbol($1); }
  |componentsymbol
  |plugsymbol { CurComponentType->AddSymbol($1); }
  |bussymbol { CurComponentType->AddSymbol($1); }
  |boxsymbol { CurComponentType->AddSymbol($1); }
  |varsymbol { CurComponentType->AddSymbol($1); }
  |symbolcopysymbol { CurComponentType->AddSymbol($1); }
  |attributes { CurComponentType->AddAttributes($1); }
  
/*****************************************
        COMPONENT (only in component)
******************************************/

componentsymbol:
  NAME componentconstructorlist { CurComponentType->AddComponent($1, $2); };

componentconstructorlist
  :componentconstructor { $$ = new list<componentconstructor>($1, (list<componentconstructor> *) NULL); }
  |componentconstructor COMMA componentconstructorlist { $$ = new list<componentconstructor>($1, $3); }

componentconstructor
  :symbolname { $$ = new componentconstructor($1.name, $1.attribs, CurComponentType); }

/*****************************************
	          BOX
******************************************/

boxsymbol  
  :HBOX LEFT_CURLY boxdefs RIGHT_CURLY { $3->settype(BOX_H); $3->initialize(symbtable.toid(""), nullattribute); $3->revconstructors(); $$ = $3; }
  |VBOX LEFT_CURLY boxdefs RIGHT_CURLY { $3->settype(BOX_V); $3->initialize(symbtable.toid(""), nullattribute); $3->revconstructors(); $$ = $3; }
  |HBOX symbolname LEFT_CURLY boxdefs RIGHT_CURLY { $4->settype(BOX_H); $4->initialize($2.name, $2.attribs); $4->revconstructors(); $$ = $4; }
  |VBOX symbolname LEFT_CURLY boxdefs RIGHT_CURLY { $4->settype(BOX_V); $4->initialize($2.name, $2.attribs); $4->revconstructors(); $$ = $4; }

boxdefs
: { $$ = new displayboxconstructor(nullattribute /*12345*//*paddingattribute()*/); }
  | boxdefs boxdef SEMICOLON { $$ = $1; $$->addconstructor($2); }
  | boxdefs attributes SEMICOLON { $$ = $1; $$->addattribs($2); }

boxdef
  :boxsymbol { $$ = $1; }  
  |symbolcopysymbol { $$ = $1; }
  |plugsymbol { $$ = $1; }
  |varsymbol { $$ = $1; }

/*****************************************
	PLUG (only in component)
******************************************/

plugsymbol
  :PLUG { ParsingPlug = 1; } LEFT_POINTY namelist RIGHT_POINTY { ParsingPlug = 0; $$ = new plugconstructor(symbtable.toid(""), nullattribute, $4); }
  |PLUG { ParsingPlug = 1; } symbolname LEFT_POINTY namelist RIGHT_POINTY { ParsingPlug = 0; $$ = new plugconstructor($3.name, $3.attribs, $5); }
  |NAME LEFT_POINTY { ParsingPlug = 1; } namelist RIGHT_POINTY { ParsingPlug = 0; $$ = new plugconstructor(symbtable.toid(""), nullattribute, $4, Project.GetPlugType($1)); }
  |NAME symbolname LEFT_POINTY { ParsingPlug = 1; } namelist RIGHT_POINTY { ParsingPlug = 0; $$ = new plugconstructor($2.name, $2.attribs, $5, Project.GetPlugType($1)); }

/*****************************************
        PLUGTYPE (only in component)
******************************************/

plugtype 
  :PLUGTYPE NAME LEFT_POINTY namelist RIGHT_POINTY {  Project.plugtypes = new list<plugtype>(new plugtype($2, $4), Project.plugtypes); }

/*****************************************
		 VAR
******************************************/

varsymbol
  :VAR LEFT_POINTY namelist RIGHT_POINTY { $$ = new variableconstructor(symbtable.toid(""), nullattribute,$3); }
  |VAR symbolname LEFT_POINTY namelist RIGHT_POINTY { $$ = new variableconstructor($2.name, $2.attribs, $4); }

/*****************************************
       BUS (only in component)
******************************************/

bussymbol
  :BUS pluglist { $$ = new busconstructor(symbtable.toid(""), nullattribute, $2, $1); }
  |BUS symbolname pluglist { $$ = new busconstructor($2.name, $2.attribs, $3, $1); }

pluglist
  :composedname { $$ = new list<symbolname>($1, (list<symbolname> *) NULL); }
  |composedname EQUAL pluglist { $$ = new list<symbolname>($1, $3); };


/*****************************************
		  SYMBOLCOPY
******************************************/

symbolcopysymbol
  :SYMBOL symbolname composedname { $$ = new symbolcopyconstructor($2.name, $2.attribs, $3); }
  |SYMBOL composedname { $$ = new symbolcopyconstructor(symbtable.toid(""), nullattribute, $2); }

/*****************************************
	  NET (only in component)
******************************************/

netsymbol
  :NET pinlist { $$ = new netconstructor(symbtable.toid(""), nullattribute, $2); }
  |NET symbolname pinlist { $$ = new netconstructor($2.name, $2.attribs, $3); }

pinlist
  :composedname { $$ = new list<symbolname>($1, (list<symbolname> *) NULL); }
  |composedname MINUS pinlist { $$ = new list<symbolname>($1, $3); };

/*****************************************
		  NAME LISTS
******************************************/

namelist
/*  :LEFT_POINTY namelistdef RIGHT_POINTY { $$ = $2; } */
  :namelistdef { $$ = $1; if ($$->elem == NULL) yyerror("Empty namelist is invalid!"); } 

namelistdef
  :namelistsymbolname { $$ = $1; }
  |namelistsymbolname COLON namelistdef { $$ = addtoend($3, $1); }

namelistsymbolname
  : { $$ = new list<symbolname>((symbolname *) NULL); }
  |NAME { $$ = new list<symbolname>(new symbolname(new int($1))); }
  |NAME SLASH namelistsymbolnametail 
    { 
      for (list<symbolname> *l = $3; l != NULL; l = l->next)
	l->elem = new symbolname(new int($1), l->elem);
      $$ = $3;
    }

namelistsymbolnametail
  :extendedname { $$ = new list<symbolname>(new symbolname(new int($1))); }
  |range 
  {
      $$ = (list<symbolname> *) NULL;
      for (int i = $1.i2; i >= $1.i1; i--)
	$$ = new list<symbolname>(new symbolname(new int(i)), $$);
  }  
  |extendedname SLASH namelistsymbolnametail
    { 
      for (list<symbolname> *l = $3; l != NULL; l = l->next)
	l->elem = new symbolname(new int($1), l->elem);
      $$ = $3;
    }
  |range SLASH namelistsymbolnametail
    { // Memory leak!
      // Iterate deepest first.
      $$ = (list<symbolname> *) NULL;
      revlist($3);
      for (int i = $1.i2; i >= $1.i1; i--)
      {
	int *iptr = new int(i);
	for (list<symbolname> *l = $3; l != NULL; l = l->next)
	  $$ = new list<symbolname>(new symbolname(iptr, l->elem), $$);
      }
    }

range
  :INTEGER TILDA INTEGER { $$.i2 = $1; $$.i1 = $3; if ($$.i1 > $$.i2) yyerror("Invalid range %i~%i, bits come in decreasing order.", $$.i2, $$.i1); if ($$.i1 < 0) yyerror("Invalid range %i~%i, negative bit numbers are invalid.", $$.i2, $$.i1); }

/*****************************************
		  NAMES
******************************************/

composedname
  :NAME { $$ = new symbolname(new int($1), (symbolname *) NULL); }
  |NAME SLASH composednametail { $$ = new symbolname(new int($1), $3); }

composednametail
  :extendedname { $$ = new symbolname(new int($1), (symbolname *) NULL); }
  |extendedname SLASH composednametail { $$ = new symbolname(new int($1), $3); }

extendedname
  :NAME { $$ = $1; }
  |INTEGER { if ($1 < 0) yyerror("Negative subscripts not allowed."); $$ = $1; }

/*****************************************
		 ATTRIBUTES
******************************************/

symbolname 
  : NAME { $$.attribs = nullattribute; $$.name = $1; }
  | NAME LEFT_PAREN attributes RIGHT_PAREN { $$.name = $1; $$.attribs = $3; }
  | LEFT_PAREN attributes RIGHT_PAREN { $$.name = symbtable.toid(""); $$.attribs = $2; }

attributes
  :attribute { $$ = $1; }
  |attribute COMMA attributes { $$ = $3->addattribute($1); }

attribute
  :NAME EQUAL INTEGER { $$ = intattribute($1, $3); }
  |NAME EQUAL REAL { $$ = realattribute($1, $3); } 
  |NAME EQUAL INTEGER UNIT { $$ = realattribute($1, ((real) $3) * $4); }
  |NAME EQUAL REAL UNIT { $$ = realattribute($1, $3 * $4); } 
  |NAME EQUAL composedname { $$ = nameattribute($1, $3); }
  |NAME EQUAL STRING { $$ = stringattribute($1, $3); }
  |NAME EQUAL PERCENT NAME { $$ = pointerattribute($1, $4); }
  |NAME EQUAL { $$ = emptyattribute($1); }
 
%%

